/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { BaseElement } from "./BaseElement";
import { WCNativeHelper } from "./WCNativeHelper";
import { enumGetBox, EnumUtil, markType } from "igniteui-react-core";
import { CarouselIndicatorsOrientation_$type } from "./CarouselIndicatorsOrientation";
import { CarouselAnimationType_$type } from "./CarouselAnimationType";
import { NumberEventArgs } from "./NumberEventArgs";
import { VoidEventArgs } from "./VoidEventArgs";
import { CarouselAnimationDirection_$type } from "./CarouselAnimationDirection";
/**
 * @hidden
 */
export let Carousel = /*@__PURE__*/ (() => {
    class Carousel extends BaseElement {
        constructor() {
            super(...arguments);
            this.f = new WCNativeHelper();
            this.v = null;
            this.slideChanged = null;
            this.playing = null;
            this.paused = null;
        }
        get g() {
            return this.f;
        }
        get nativeElement() {
            return this.v;
        }
        set nativeElement(a) {
            this.v = a;
            this.f.o = this.v;
        }
        setNativeElement(a) {
            this.nativeElement = a;
        }
        get h() {
            let ret_ = this.g.n("disableLoop");
            return ret_;
        }
        set h(a) {
            let value_ = a;
            this.g.w("disableLoop", value_);
        }
        get i() {
            let ret_ = this.g.n("disablePauseOnInteraction");
            return ret_;
        }
        set i(a) {
            let value_ = a;
            this.g.w("disablePauseOnInteraction", value_);
        }
        get k() {
            let ret_ = this.g.n("hideNavigation");
            return ret_;
        }
        set k(a) {
            let value_ = a;
            this.g.w("hideNavigation", value_);
        }
        get j() {
            let ret_ = this.g.n("hideIndicators");
            return ret_;
        }
        set j(a) {
            let value_ = a;
            this.g.w("hideIndicators", value_);
        }
        get q() {
            let ret_ = this.g.n("vertical");
            return ret_;
        }
        set q(a) {
            let value_ = a;
            this.g.w("vertical", value_);
        }
        get b() {
            let ret_ = this.g.n("indicatorsOrientation");
            if ((ret_ === undefined && this.___rawMode)) {
                return undefined;
            }
            ret_ = enumGetBox(CarouselIndicatorsOrientation_$type, EnumUtil.getEnumValue(CarouselIndicatorsOrientation_$type, this.g.f(CarouselIndicatorsOrientation_$type, ret_)));
            return EnumUtil.getEnumValue(CarouselIndicatorsOrientation_$type, ret_);
        }
        set b(a) {
            let value_ = enumGetBox(CarouselIndicatorsOrientation_$type, a);
            value_ = WCNativeHelper.camel(value_.toString());
            this.g.w("indicatorsOrientation", value_);
        }
        get x() {
            let ret_ = this.g.n("indicatorsLabelFormat");
            return ret_;
        }
        set x(a) {
            let value_ = a;
            this.g.w("indicatorsLabelFormat", value_);
        }
        get y() {
            let ret_ = this.g.n("slidesLabelFormat");
            return ret_;
        }
        set y(a) {
            let value_ = a;
            this.g.w("slidesLabelFormat", value_);
        }
        get s() {
            let ret_ = this.g.n("interval");
            return ret_;
        }
        set s(a) {
            let value_ = a;
            this.g.w("interval", value_);
        }
        get t() {
            let ret_ = this.g.n("maximumIndicatorsCount");
            return ret_;
        }
        set t(a) {
            let value_ = a;
            this.g.w("maximumIndicatorsCount", value_);
        }
        get a() {
            let ret_ = this.g.n("animationType");
            if ((ret_ === undefined && this.___rawMode)) {
                return undefined;
            }
            ret_ = enumGetBox(CarouselAnimationType_$type, EnumUtil.getEnumValue(CarouselAnimationType_$type, this.g.f(CarouselAnimationType_$type, ret_)));
            return EnumUtil.getEnumValue(CarouselAnimationType_$type, ret_);
        }
        set a(a) {
            let value_ = enumGetBox(CarouselAnimationType_$type, a);
            value_ = WCNativeHelper.camel(value_.toString());
            this.g.w("animationType", value_);
        }
        get u() {
            let ret_ = this.g.n("total");
            return ret_;
        }
        get r() {
            let ret_ = this.g.n("current");
            return ret_;
        }
        get m() {
            let ret_ = this.g.n("isPlaying");
            return ret_;
        }
        get l() {
            let ret_ = this.g.n("isPaused");
            return ret_;
        }
        slideChangedChanged() {
            if (this.slideChanged != null) {
                this.g.s("slideChanged", (a) => this.slideChanged(this, NumberEventArgs.a(a)));
            }
            else {
                this.g.v("slideChanged");
            }
        }
        playingChanged() {
            if (this.playing != null) {
                this.g.s("playing", (a) => this.playing(this, VoidEventArgs.b(a)));
            }
            else {
                this.g.v("playing");
            }
        }
        pausedChanged() {
            if (this.paused != null) {
                this.g.s("paused", (a) => this.paused(this, VoidEventArgs.b(a)));
            }
            else {
                this.g.v("paused");
            }
        }
        ab() {
            this.nativeElement.play();
        }
        z() {
            this.nativeElement.pause();
        }
        n() {
            return (this.nativeElement.next());
        }
        o() {
            return (this.nativeElement.prev());
        }
        p(a, b) {
            return (this.nativeElement.select(this.g.i(a), this.g.i(enumGetBox(CarouselAnimationDirection_$type, b))));
        }
    }
    Carousel.$t = /*@__PURE__*/ markType(Carousel, 'Carousel', BaseElement.$);
    return Carousel;
})();
