/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { BaseElement } from "./BaseElement";
import { WCNativeHelper } from "./WCNativeHelper";
import { enumGetBox, EnumUtil, markType } from "igniteui-react-core";
import { DockManagerLayout } from "./DockManagerLayout";
import { DockManagerPane } from "./DockManagerPane";
import { DockManagerPoint } from "./DockManagerPoint";
import { ContentPane } from "./ContentPane";
import { DockManagerShowHeaderIconOnHover_$type } from "./DockManagerShowHeaderIconOnHover";
import { DockManagerResourceStrings } from "./DockManagerResourceStrings";
import { DockManagerShowPaneHeaders_$type } from "./DockManagerShowPaneHeaders";
import { PaneActionBehavior_$type } from "./PaneActionBehavior";
import { LayoutChangeEventArgs } from "./LayoutChangeEventArgs";
/**
 * @hidden
 */
export let DockManager = /*@__PURE__*/ (() => {
    class DockManager extends BaseElement {
        constructor() {
            super(...arguments);
            this.layoutChange = null;
            this.l = new WCNativeHelper();
            this.t = null;
        }
        layoutChangeChanged() {
            if (this.layoutChange != null) {
                this.m.s("layoutChange", (a) => this.layoutChange(this, LayoutChangeEventArgs.b(this.b)), false);
            }
            else {
                this.m.v("layoutChange");
            }
        }
        get m() {
            return this.l;
        }
        get nativeElement() {
            return this.t;
        }
        set nativeElement(a) {
            this.t = a;
            this.l.o = this.t;
        }
        setNativeElement(a) {
            this.nativeElement = a;
        }
        get b() {
            let ret_ = this.m.m("layout", (a) => new DockManagerLayout());
            return ret_;
        }
        set b(a) {
            let value_ = a;
            this.m.w("layout", value_);
        }
        get c() {
            let ret_ = this.m.m("draggedPane", (a) => DockManagerPane.createFromNative(a));
            return ret_;
        }
        set c(a) {
            let value_ = a;
            this.m.w("draggedPane", value_);
        }
        get e() {
            let ret_ = this.m.m("dropPosition", (a) => new DockManagerPoint());
            return ret_;
        }
        set e(a) {
            let value_ = a;
            this.m.w("dropPosition", value_);
        }
        get a() {
            let ret_ = this.m.m("activePane", (a) => new ContentPane());
            return ret_;
        }
        set a(a) {
            let value_ = a;
            this.m.w("activePane", value_);
        }
        get p() {
            let ret_ = this.m.n("allowMaximize");
            return ret_;
        }
        set p(a) {
            let value_ = a;
            this.m.w("allowMaximize", value_);
        }
        get q() {
            let ret_ = this.m.n("containedInBoundaries");
            return ret_;
        }
        set q(a) {
            let value_ = a;
            this.m.w("containedInBoundaries", value_);
        }
        get g() {
            let ret_ = this.m.n("showHeaderIconOnHover");
            if ((ret_ === undefined && this.___rawMode)) {
                return undefined;
            }
            ret_ = enumGetBox(DockManagerShowHeaderIconOnHover_$type, EnumUtil.getEnumValue(DockManagerShowHeaderIconOnHover_$type, this.m.f(DockManagerShowHeaderIconOnHover_$type, ret_)));
            return EnumUtil.getEnumValue(DockManagerShowHeaderIconOnHover_$type, ret_);
        }
        set g(a) {
            let value_ = enumGetBox(DockManagerShowHeaderIconOnHover_$type, a);
            value_ = WCNativeHelper.camel(value_.toString());
            this.m.w("showHeaderIconOnHover", value_);
        }
        get d() {
            let ret_ = this.m.m("maximizedPane", (a) => DockManagerPane.createFromNative(a));
            return ret_;
        }
        set d(a) {
            let value_ = a;
            this.m.w("maximizedPane", value_);
        }
        get f() {
            let ret_ = this.m.m("resourceStrings", (a) => new DockManagerResourceStrings());
            return ret_;
        }
        set f(a) {
            let value_ = a;
            this.m.w("resourceStrings", value_);
        }
        get n() {
            let ret_ = this.m.n("allowFloatingPanesResize");
            return ret_;
        }
        set n(a) {
            let value_ = a;
            this.m.w("allowFloatingPanesResize", value_);
        }
        get r() {
            let ret_ = this.m.n("disableKeyboardNavigation");
            return ret_;
        }
        set r(a) {
            let value_ = a;
            this.m.w("disableKeyboardNavigation", value_);
        }
        get o() {
            let ret_ = this.m.n("allowInnerDock");
            return ret_;
        }
        set o(a) {
            let value_ = a;
            this.m.w("allowInnerDock", value_);
        }
        get h() {
            let ret_ = this.m.n("showPaneHeaders");
            if ((ret_ === undefined && this.___rawMode)) {
                return undefined;
            }
            ret_ = enumGetBox(DockManagerShowPaneHeaders_$type, EnumUtil.getEnumValue(DockManagerShowPaneHeaders_$type, this.m.f(DockManagerShowPaneHeaders_$type, ret_)));
            return EnumUtil.getEnumValue(DockManagerShowPaneHeaders_$type, ret_);
        }
        set h(a) {
            let value_ = enumGetBox(DockManagerShowPaneHeaders_$type, a);
            value_ = WCNativeHelper.camel(value_.toString());
            this.m.w("showPaneHeaders", value_);
        }
        get s() {
            let ret_ = this.m.n("proximityDock");
            return ret_;
        }
        set s(a) {
            let value_ = a;
            this.m.w("proximityDock", value_);
        }
        get j() {
            let ret_ = this.m.n("closeBehavior");
            if ((ret_ === undefined && this.___rawMode)) {
                return undefined;
            }
            ret_ = enumGetBox(PaneActionBehavior_$type, EnumUtil.getEnumValue(PaneActionBehavior_$type, this.m.f(PaneActionBehavior_$type, ret_)));
            return EnumUtil.getEnumValue(PaneActionBehavior_$type, ret_);
        }
        set j(a) {
            let value_ = enumGetBox(PaneActionBehavior_$type, a);
            value_ = WCNativeHelper.camel(value_.toString());
            this.m.w("closeBehavior", value_);
        }
        get k() {
            let ret_ = this.m.n("unpinBehavior");
            if ((ret_ === undefined && this.___rawMode)) {
                return undefined;
            }
            ret_ = enumGetBox(PaneActionBehavior_$type, EnumUtil.getEnumValue(PaneActionBehavior_$type, this.m.f(PaneActionBehavior_$type, ret_)));
            return EnumUtil.getEnumValue(PaneActionBehavior_$type, ret_);
        }
        set k(a) {
            let value_ = enumGetBox(PaneActionBehavior_$type, a);
            value_ = WCNativeHelper.camel(value_.toString());
            this.m.w("unpinBehavior", value_);
        }
        v(a) {
            this.nativeElement.focusPane(this.m.i(a));
        }
    }
    DockManager.$t = /*@__PURE__*/ markType(DockManager, 'DockManager', BaseElement.$);
    return DockManager;
})();
