import { KeyBindingHandler as KeyBindingHandler_internal } from "./KeyBindingHandler";
var IgrKeyBindingHandler = /** @class */ /*@__PURE__*/ (function () {
    function IgrKeyBindingHandler() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgrKeyBindingHandler.prototype.createImplementation = function () {
        return new KeyBindingHandler_internal();
    };
    Object.defineProperty(IgrKeyBindingHandler.prototype, "nativeElement", {
        get: function () {
            return this._implementation.nativeElement;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrKeyBindingHandler.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrKeyBindingHandler.prototype.onImplementationCreated = function () {
    };
    IgrKeyBindingHandler.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    IgrKeyBindingHandler.prototype.findByName = function (name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        return null;
    };
    return IgrKeyBindingHandler;
}());
export { IgrKeyBindingHandler };
