import { IgrDockManagerPane } from "./igr-dock-manager-pane";
import { SplitPaneOrientation_$type } from "./SplitPaneOrientation";
import { SplitterResizeEventArgs as SplitterResizeEventArgs_internal } from "./SplitterResizeEventArgs";
import { ensureEnum } from "igniteui-react-core";
var IgrSplitterResizeEventArgs = /** @class */ /*@__PURE__*/ (function () {
    function IgrSplitterResizeEventArgs() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgrSplitterResizeEventArgs.prototype.createImplementation = function () {
        return new SplitterResizeEventArgs_internal();
    };
    Object.defineProperty(IgrSplitterResizeEventArgs.prototype, "nativeElement", {
        get: function () {
            return this._implementation.nativeElement;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrSplitterResizeEventArgs.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrSplitterResizeEventArgs.prototype.onImplementationCreated = function () {
    };
    IgrSplitterResizeEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    Object.defineProperty(IgrSplitterResizeEventArgs.prototype, "pane", {
        /**
         * Gets the pane being resized with the splitter.
        */
        get: function () {
            var r = this.i.a;
            if (r == null) {
                return null;
            }
            if (!r.externalObject) {
                var e = IgrDockManagerPane._createFromInternal(r);
                if (e) {
                    e._implementation = r;
                }
                r.externalObject = e;
            }
            return r.externalObject;
        },
        set: function (v) {
            v == null ? this.i.a = null : this.i.a = v.i;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrSplitterResizeEventArgs.prototype, "orientation", {
        /**
         * Gets the pane's orientation.
        */
        get: function () {
            return this.i.b;
        },
        set: function (v) {
            this.i.b = ensureEnum(SplitPaneOrientation_$type, v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrSplitterResizeEventArgs.prototype, "paneWidth", {
        /**
         * Gets the pane's width.
        */
        get: function () {
            return this.i.d;
        },
        set: function (v) {
            this.i.d = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrSplitterResizeEventArgs.prototype, "paneHeight", {
        /**
         * Gets the pane's height.
        */
        get: function () {
            return this.i.c;
        },
        set: function (v) {
            this.i.c = +v;
        },
        enumerable: false,
        configurable: true
    });
    return IgrSplitterResizeEventArgs;
}());
export { IgrSplitterResizeEventArgs };
