import { ValidatorHandler as ValidatorHandler_internal } from "./ValidatorHandler";
var IgrValidatorHandler = /** @class */ /*@__PURE__*/ (function () {
    function IgrValidatorHandler() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgrValidatorHandler.prototype.createImplementation = function () {
        return new ValidatorHandler_internal();
    };
    Object.defineProperty(IgrValidatorHandler.prototype, "nativeElement", {
        get: function () {
            return this._implementation.nativeElement;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrValidatorHandler.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrValidatorHandler.prototype.onImplementationCreated = function () {
    };
    IgrValidatorHandler.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    IgrValidatorHandler.prototype.findByName = function (name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        return null;
    };
    return IgrValidatorHandler;
}());
export { IgrValidatorHandler };
