import * as React from 'react';
import { CalendarBaseSelection } from "./CalendarBaseSelection";
import { WeekDays } from "./WeekDays";
import { CalendarBase } from "./CalendarBase";
import { ReactRenderer, PortalManager } from "igniteui-react-core";
import { ContentChildrenManager } from "igniteui-react-core";
import { IDateRangeDescriptor } from "./IDateRangeDescriptor";
export declare class IgrCalendarBase<P extends IIgrCalendarBaseProps = IIgrCalendarBaseProps> extends React.Component<P & Omit<React.HTMLAttributes<HTMLElement>, keyof P>, {}> {
    protected createImplementation(): CalendarBase;
    protected _implementation: any;
    protected mounted: boolean;
    get nativeElement(): HTMLElement;
    /**
     * @hidden
     */
    get i(): CalendarBase; /**
                                 * @hidden
                                 */
    static _createFromInternal(internal: any): IgrCalendarBase;
    protected _renderer: ReactRenderer;
    protected _portalManager: PortalManager;
    protected onImplementationCreated(): void;
    protected _contentChildrenManager: ContentChildrenManager;
    constructor(props: P & Omit<React.HTMLAttributes<HTMLElement>, keyof P>);
    componentDidMount(): void;
    shouldComponentUpdate(nextProps: any, nextState: any): boolean;
    render(): React.DOMElement<{
        ref: (ref: any) => void;
        id: (P & Omit<React.HTMLAttributes<HTMLElement>, keyof P>)["id"];
        class: (P & Omit<React.HTMLAttributes<HTMLElement>, keyof P>)["className"];
        style: {};
        children: any[];
    }, any>;
    protected _elRef: HTMLElement;
    protected _getMainRef(ref: any): void;
    /**
     * Sets the type of selection in the component.
    */
    get selection(): CalendarBaseSelection;
    set selection(v: CalendarBaseSelection);
    /**
     * Whether to show the week numbers.
    */
    get showWeekNumbers(): boolean;
    set showWeekNumbers(v: boolean);
    /**
     * Gets/Sets the first day of the week.
    */
    get weekStart(): WeekDays;
    set weekStart(v: WeekDays);
    /**
     * Gets/Sets the locale used for formatting and displaying the dates in the component.
    */
    get locale(): string;
    set locale(v: string);
    /**
     * Gets/Sets the special dates for the component.
    */
    get specialDates(): IDateRangeDescriptor[];
    set specialDates(v: IDateRangeDescriptor[]);
    /**
     * Gets/Sets the disabled dates for the component.
    */
    get disabledDates(): IDateRangeDescriptor[];
    set disabledDates(v: IDateRangeDescriptor[]);
    findByName(name: string): any;
    protected __p: string;
    protected _hasUserValues: Set<string>;
    protected get hasUserValues(): Set<string>;
    protected __m(propertyName: string): void;
    protected _stylingContainer: any;
    protected _stylingParent: any;
    protected _inStyling: boolean;
    protected _styling(container: any, component: any, parent?: any): void;
    setNativeElement(element: any): void;
}
export interface IIgrCalendarBaseProps {
    children?: React.ReactNode;
    id?: string | undefined;
    className?: string | undefined;
    style?: React.CSSProperties | undefined;
    /**
     * Sets the type of selection in the component.
    */
    selection?: CalendarBaseSelection | string;
    /**
     * Whether to show the week numbers.
    */
    showWeekNumbers?: boolean | string;
    /**
     * Gets/Sets the first day of the week.
    */
    weekStart?: WeekDays | string;
    /**
     * Gets/Sets the locale used for formatting and displaying the dates in the component.
    */
    locale?: string;
    /**
     * Gets/Sets the special dates for the component.
    */
    specialDates?: IDateRangeDescriptor[];
    /**
     * Gets/Sets the disabled dates for the component.
    */
    disabledDates?: IDateRangeDescriptor[];
}
