import * as React from 'react';
import { CarouselSlideType } from "./CarouselSlideType";
import { CarouselSlideDirection } from "./CarouselSlideDirection";
import { CarouselSlide } from "./CarouselSlide";
import { ReactRenderer, PortalManager } from "igniteui-react-core";
import { ContentChildrenManager } from "igniteui-react-core";
/**
 * A single content container within a set of containers used in the context of an `igc-carousel`.
*/
export declare class IgrCarouselSlide<P extends IIgrCarouselSlideProps = IIgrCarouselSlideProps> extends React.Component<P & Omit<React.HTMLAttributes<HTMLElement>, keyof P>, {}> {
    protected createImplementation(): CarouselSlide;
    protected _implementation: any;
    protected mounted: boolean;
    get nativeElement(): HTMLElement;
    /**
     * @hidden
     */
    get i(): CarouselSlide; /**
                                 * @hidden
                                 */
    static _createFromInternal(internal: any): IgrCarouselSlide;
    protected _renderer: ReactRenderer;
    protected _portalManager: PortalManager;
    protected onImplementationCreated(): void;
    protected _contentChildrenManager: ContentChildrenManager;
    constructor(props: P & Omit<React.HTMLAttributes<HTMLElement>, keyof P>);
    componentDidMount(): void;
    shouldComponentUpdate(nextProps: any, nextState: any): boolean;
    render(): React.DOMElement<{
        ref: (ref: any) => void;
        id: (P & Omit<React.HTMLAttributes<HTMLElement>, keyof P>)["id"];
        class: (P & Omit<React.HTMLAttributes<HTMLElement>, keyof P>)["className"];
        style: {};
        children: any[];
    }, any>;
    protected _elRef: HTMLElement;
    protected _getMainRef(ref: any): void;
    /**
     * The current active slide for the carousel component.
    */
    get active(): boolean;
    set active(v: boolean);
    findByName(name: string): any;
    protected __p: string;
    protected _hasUserValues: Set<string>;
    protected get hasUserValues(): Set<string>;
    protected __m(propertyName: string): void;
    protected _stylingContainer: any;
    protected _stylingParent: any;
    protected _inStyling: boolean;
    protected _styling(container: any, component: any, parent?: any): void;
    setNativeElement(element: any): void;
    toggleAnimation(type: CarouselSlideType, direction: CarouselSlideDirection): void;
    connectedCallback(): void;
}
export interface IIgrCarouselSlideProps {
    children?: React.ReactNode;
    id?: string | undefined;
    className?: string | undefined;
    style?: React.CSSProperties | undefined;
    /**
     * The current active slide for the carousel component.
    */
    active?: boolean | string;
}
