import * as React from 'react';
import { CheckboxBaseLabelPosition } from "./CheckboxBaseLabelPosition";
import { IgrCheckboxChangeEventArgs } from "./igr-checkbox-change-event-args";
import { IgrVoidEventArgs } from "./igr-void-event-args";
import { IgrFocusOptions } from "./igr-focus-options";
import { CheckboxBase } from "./CheckboxBase";
import { ReactRenderer, PortalManager } from "igniteui-react-core";
import { ContentChildrenManager } from "igniteui-react-core";
export declare class IgrCheckboxBase<P extends IIgrCheckboxBaseProps = IIgrCheckboxBaseProps> extends React.Component<P & Omit<React.HTMLAttributes<HTMLElement>, keyof P>, {}> {
    protected createImplementation(): CheckboxBase;
    protected _implementation: any;
    protected mounted: boolean;
    get nativeElement(): HTMLElement;
    /**
     * @hidden
     */
    get i(): CheckboxBase; /**
                                 * @hidden
                                 */
    static _createFromInternal(internal: any): IgrCheckboxBase;
    protected _renderer: ReactRenderer;
    protected _portalManager: PortalManager;
    protected onImplementationCreated(): void;
    protected _contentChildrenManager: ContentChildrenManager;
    constructor(props: P & Omit<React.HTMLAttributes<HTMLElement>, keyof P>);
    componentDidMount(): void;
    shouldComponentUpdate(nextProps: any, nextState: any): boolean;
    render(): React.DOMElement<{
        ref: (ref: any) => void;
        id: (P & Omit<React.HTMLAttributes<HTMLElement>, keyof P>)["id"];
        class: (P & Omit<React.HTMLAttributes<HTMLElement>, keyof P>)["className"];
        style: {};
        children: any[];
    }, any>;
    protected _elRef: HTMLElement;
    protected _getMainRef(ref: any): void;
    /**
     * The value attribute of the control.
    */
    get value(): string;
    set value(v: string);
    /**
     * The checked state of the control.
    */
    get checked(): boolean;
    set checked(v: boolean);
    /**
     * The label position of the control.
    */
    get labelPosition(): CheckboxBaseLabelPosition;
    set labelPosition(v: CheckboxBaseLabelPosition);
    /**
     * The disabled state of the component
    */
    get disabled(): boolean;
    set disabled(v: boolean);
    /**
     * Makes the control a required field in a form context.
    */
    get required(): boolean;
    set required(v: boolean);
    /**
     * The name attribute of the control.
    */
    get name(): string;
    set name(v: string);
    /**
     * Control the validity of the control.
    */
    get invalid(): boolean;
    set invalid(v: boolean);
    findByName(name: string): any;
    protected __p: string;
    protected _hasUserValues: Set<string>;
    protected get hasUserValues(): Set<string>;
    protected __m(propertyName: string): void;
    protected _stylingContainer: any;
    protected _stylingParent: any;
    protected _inStyling: boolean;
    protected _styling(container: any, component: any, parent?: any): void;
    setNativeElement(element: any): void;
    /**
     * Simulates a click on the control.
    
    */
    click(): void;
    /**
     * Sets focus on the control.
    
    */
    focusComponent(options: IgrFocusOptions): void;
    /**
     * Removes focus from the control.
    
    */
    blurComponent(): void;
    /**
     * Checks for validity of the control and shows the browser message if it invalid.
    
    */
    reportValidity(): void;
    /**
     * Checks for validity of the control and emits the invalid event if it invalid.
    
    */
    checkValidity(): void;
    /**
     * Sets a custom validation message for the control.
     * As long as `message` is not empty, the control is considered invalid.
    
    */
    setCustomValidity(message: string): void;
    private _change;
    private _change_wrapped;
    get change(): (s: IgrCheckboxBase, e: IgrCheckboxChangeEventArgs) => void;
    set change(ev: (s: IgrCheckboxBase, e: IgrCheckboxChangeEventArgs) => void);
    private _focus;
    private _focus_wrapped;
    get focus(): (s: IgrCheckboxBase, e: IgrVoidEventArgs) => void;
    set focus(ev: (s: IgrCheckboxBase, e: IgrVoidEventArgs) => void);
    private _blur;
    private _blur_wrapped;
    get blur(): (s: IgrCheckboxBase, e: IgrVoidEventArgs) => void;
    set blur(ev: (s: IgrCheckboxBase, e: IgrVoidEventArgs) => void);
}
export interface IIgrCheckboxBaseProps {
    children?: React.ReactNode;
    id?: string | undefined;
    className?: string | undefined;
    style?: React.CSSProperties | undefined;
    /**
     * The value attribute of the control.
    */
    value?: string;
    /**
     * The checked state of the control.
    */
    checked?: boolean | string;
    /**
     * The label position of the control.
    */
    labelPosition?: CheckboxBaseLabelPosition | string;
    /**
     * The disabled state of the component
    */
    disabled?: boolean | string;
    /**
     * Makes the control a required field in a form context.
    */
    required?: boolean | string;
    /**
     * The name attribute of the control.
    */
    name?: string;
    /**
     * Control the validity of the control.
    */
    invalid?: boolean | string;
    change?: (s: IgrCheckboxBase, e: IgrCheckboxChangeEventArgs) => void;
    focus?: (s: IgrCheckboxBase, e: IgrVoidEventArgs) => void;
    blur?: (s: IgrCheckboxBase, e: IgrVoidEventArgs) => void;
}
