import * as React from 'react';
import { IgrInputBase, IIgrInputBaseProps } from "./igr-input-base";
import { MaskInputBase } from "./MaskInputBase";
export declare abstract class IgrMaskInputBase<P extends IIgrMaskInputBaseProps = IIgrMaskInputBaseProps> extends IgrInputBase<P> {
    /**
                                 * @hidden
                                 */
    get i(): MaskInputBase;
    constructor(props: P & Omit<React.HTMLAttributes<HTMLElement>, keyof P>);
    /**
     * The prompt symbol to use for unfilled parts of the mask.
    */
    get prompt(): string;
    set prompt(v: string);
    connectedCallback(): void;
    /**
     * Selects all text within the input.
    
    */
    select(): void;
}
export interface IIgrMaskInputBaseProps extends IIgrInputBaseProps {
    /**
     * The prompt symbol to use for unfilled parts of the mask.
    */
    prompt?: string;
}
