import * as React from 'react';
import { NavDrawerPosition } from "./NavDrawerPosition";
import { NavDrawer } from "./NavDrawer";
import { ReactRenderer, PortalManager } from "igniteui-react-core";
import { ContentChildrenManager } from "igniteui-react-core";
/**
 * Represents a side navigation container that provides
 * quick access between views.
*/
export declare class IgrNavDrawer<P extends IIgrNavDrawerProps = IIgrNavDrawerProps> extends React.Component<P & Omit<React.HTMLAttributes<HTMLElement>, keyof P>, {}> {
    protected createImplementation(): NavDrawer;
    protected _implementation: any;
    protected mounted: boolean;
    get nativeElement(): HTMLElement;
    /**
     * @hidden
     */
    get i(): NavDrawer; /**
                                 * @hidden
                                 */
    static _createFromInternal(internal: any): IgrNavDrawer;
    protected _renderer: ReactRenderer;
    protected _portalManager: PortalManager;
    protected onImplementationCreated(): void;
    protected _contentChildrenManager: ContentChildrenManager;
    constructor(props: P & Omit<React.HTMLAttributes<HTMLElement>, keyof P>);
    componentDidMount(): void;
    shouldComponentUpdate(nextProps: any, nextState: any): boolean;
    render(): React.DOMElement<{
        ref: (ref: any) => void;
        id: (P & Omit<React.HTMLAttributes<HTMLElement>, keyof P>)["id"];
        class: (P & Omit<React.HTMLAttributes<HTMLElement>, keyof P>)["className"];
        style: {};
        children: any[];
    }, any>;
    protected _elRef: HTMLElement;
    protected _getMainRef(ref: any): void;
    /**
     * The position of the drawer.
    */
    get position(): NavDrawerPosition;
    set position(v: NavDrawerPosition);
    /**
     * Determines whether the drawer is opened.
    */
    get open(): boolean;
    set open(v: boolean);
    findByName(name: string): any;
    protected __p: string;
    protected _hasUserValues: Set<string>;
    protected get hasUserValues(): Set<string>;
    protected __m(propertyName: string): void;
    protected _stylingContainer: any;
    protected _stylingParent: any;
    protected _inStyling: boolean;
    protected _styling(container: any, component: any, parent?: any): void;
    setNativeElement(element: any): void;
    /**
     * Opens the drawer.
    
    */
    show(): boolean;
    /**
     * Closes the drawer.
    
    */
    hide(): boolean;
    /**
     * Toggles the open state of the drawer.
    
    */
    toggle(): boolean;
}
export interface IIgrNavDrawerProps {
    children?: React.ReactNode;
    id?: string | undefined;
    className?: string | undefined;
    style?: React.CSSProperties | undefined;
    /**
     * The position of the drawer.
    */
    position?: NavDrawerPosition | string;
    /**
     * Determines whether the drawer is opened.
    */
    open?: boolean | string;
}
