import * as React from 'react';
import { RadioGroupAlignment } from "./RadioGroupAlignment";
import { IgrRadioChangeEventArgs } from "./igr-radio-change-event-args";
import { RadioGroup } from "./RadioGroup";
import { ReactRenderer, PortalManager } from "igniteui-react-core";
import { ContentChildrenManager } from "igniteui-react-core";
/**
 * The igc-radio-group component unifies one or more igc-radio buttons.
*/
export declare class IgrRadioGroup<P extends IIgrRadioGroupProps = IIgrRadioGroupProps> extends React.Component<P & Omit<React.HTMLAttributes<HTMLElement>, keyof P>, {}> {
    protected createImplementation(): RadioGroup;
    protected _implementation: any;
    protected mounted: boolean;
    get nativeElement(): HTMLElement;
    /**
     * @hidden
     */
    get i(): RadioGroup; /**
                                 * @hidden
                                 */
    static _createFromInternal(internal: any): IgrRadioGroup;
    protected _renderer: ReactRenderer;
    protected _portalManager: PortalManager;
    protected onImplementationCreated(): void;
    protected _contentChildrenManager: ContentChildrenManager;
    constructor(props: P & Omit<React.HTMLAttributes<HTMLElement>, keyof P>);
    componentDidMount(): void;
    shouldComponentUpdate(nextProps: any, nextState: any): boolean;
    render(): React.DOMElement<{
        ref: (ref: any) => void;
        id: (P & Omit<React.HTMLAttributes<HTMLElement>, keyof P>)["id"];
        class: (P & Omit<React.HTMLAttributes<HTMLElement>, keyof P>)["className"];
        style: {};
        children: any[];
    }, any>;
    protected _elRef: HTMLElement;
    protected _getMainRef(ref: any): void;
    /**
     * Alignment of the radio controls inside this group.
    */
    get alignment(): RadioGroupAlignment;
    set alignment(v: RadioGroupAlignment);
    /**
     * Gets/Sets the name for all child igc-radio components.
    */
    get name(): string;
    set name(v: string);
    /**
     * Gets/Sets the checked igc-radio element that matches `value`
    */
    get value(): string;
    set value(v: string);
    findByName(name: string): any;
    protected __p: string;
    protected _hasUserValues: Set<string>;
    protected get hasUserValues(): Set<string>;
    protected __m(propertyName: string): void;
    protected _stylingContainer: any;
    protected _stylingParent: any;
    protected _inStyling: boolean;
    protected _styling(container: any, component: any, parent?: any): void;
    setNativeElement(element: any): void;
    private _change;
    private _change_wrapped;
    get change(): (s: IgrRadioGroup, e: IgrRadioChangeEventArgs) => void;
    set change(ev: (s: IgrRadioGroup, e: IgrRadioChangeEventArgs) => void);
}
export interface IIgrRadioGroupProps {
    children?: React.ReactNode;
    id?: string | undefined;
    className?: string | undefined;
    style?: React.CSSProperties | undefined;
    /**
     * Alignment of the radio controls inside this group.
    */
    alignment?: RadioGroupAlignment | string;
    /**
     * Gets/Sets the name for all child igc-radio components.
    */
    name?: string;
    /**
     * Gets/Sets the checked igc-radio element that matches `value`
    */
    value?: string;
    change?: (s: IgrRadioGroup, e: IgrRadioChangeEventArgs) => void;
}
