import * as React from 'react';
import { IgrVoidEventArgs } from "./igr-void-event-args";
import { IgrBaseAlertLike, IIgrBaseAlertLikeProps } from "./igr-base-alert-like";
import { Snackbar } from "./Snackbar";
/**
 * A snackbar component is used to provide feedback about an operation
 * by showing a brief message at the bottom of the screen.
*/
export declare class IgrSnackbar extends IgrBaseAlertLike<IIgrSnackbarProps & Omit<React.HTMLAttributes<HTMLElement>, keyof IIgrSnackbarProps>> {
    protected createImplementation(): Snackbar;
    /**
                                 * @hidden
                                 */
    get i(): Snackbar;
    constructor(props: IIgrSnackbarProps & Omit<React.HTMLAttributes<HTMLElement>, keyof IIgrSnackbarProps>);
    componentDidMount(): void;
    render(): React.DOMElement<any, Element>;
    protected _elRef: HTMLElement;
    protected _getMainRef(ref: any): void;
    /**
     * The snackbar action button.
    */
    get actionText(): string;
    set actionText(v: string);
    private _action;
    private _action_wrapped;
    get action(): (s: IgrSnackbar, e: IgrVoidEventArgs) => void;
    set action(ev: (s: IgrSnackbar, e: IgrVoidEventArgs) => void);
}
export interface IIgrSnackbarProps extends IIgrBaseAlertLikeProps {
    /**
     * The snackbar action button.
    */
    actionText?: string;
    action?: (s: IgrSnackbar, e: IgrVoidEventArgs) => void;
}
